'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var buildCtx = function buildCtx(that) {
  var setState = that.setState.bind(that);
  return {
    setState: setState,
    get state() {
      return that.state;
    },
    set state(value) {
      setState(value);
    },
    get props() {
      return that.props;
    },
    get context() {
      return that.context;
    }
  };
};

exports.default = function (factory) {
  var _class, _temp;

  var Component = (_temp = _class = function (_React$Component) {
    _inherits(Component, _React$Component);

    function Component() {
      var _ref;

      _classCallCheck(this, Component);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var _this = _possibleConstructorReturn(this, (_ref = Component.__proto__ || Object.getPrototypeOf(Component)).call.apply(_ref, [this].concat(args)));

      var ctx = buildCtx(_this);

      var _factory = factory(ctx),
          render = _factory.render,
          properties = _objectWithoutProperties(_factory, ['render']);

      Object.assign(_this, properties);
      _this.render = function () {
        for (var _len2 = arguments.length, futureArgs = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          futureArgs[_key2] = arguments[_key2];
        }

        return render.apply(undefined, [_this.props, _this.state, _this.context].concat(futureArgs));
      };
      return _this;
    }

    return Component;
  }(_react2.default.Component), _class.displayName = factory.name, _temp);

  Object.assign(Component, factory);

  return Component;
};